'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = merge;

var _observable = require('./observable');

function merge() {
  for (var _len = arguments.length, sources = Array(_len), _key = 0; _key < _len; _key++) {
    sources[_key] = arguments[_key];
  }

  return (0, _observable.Observable)(function (add) {
    var unsubs = sources.map(function (obs) {
      return obs.subscribe(add);
    });
    return function () {
      return unsubs.forEach(function (unsub) {
        return unsub();
      });
    };
  });
}